/*****************************************************************************
 * This program illustrates a handy way, using a struct, to attach a 
 * set/not set flag to a vector like the sudoku square we have discussed. 
 ****************************************************************************/
#include <iostream>
#include <vector>
using std::cin; using std::cout;            
using std::endl;            
using std::vector;

struct square{
	vector<int> possibles;
	bool set;
};

void print_square(const square & s);
bool set_square(square & s, int value);
typedef vector<int>::size_type p_size;

int main()
{
	vector<int> V;
	for(int i=1; i!=10; i++)
		V.push_back(i);
	square s={V, false};
	print_square(s);
	if(set_square(s, 7))
		cout<<"\nYour set was successful.\n";
	else
		cout<<"\nYour set was unsuccessful.\n";
	print_square(s);
	if(set_square(s, 4))
		cout<<"\nYour set was successful.\n";
	else
		cout<<"\nYour set was unsuccessful.\n";
	print_square(s);
	return 0;
			
}

void print_square(const square & s)
{
	for(p_size i=0; i!=s.possibles.size();i++)
	{
		if(s.possibles[i]!=0)
			if(s.set)
				cout<<"("<<s.possibles[i]<<")";
			else
				cout<<s.possibles[i];
		else
			cout<<" ";
		if(i%3==2)
			cout<<endl;
	}
	if(s.set)
		cout<<"The value is set.\n";
	else
		cout<<"The value is not set.\n";
}

bool set_square(square & s, int value)
{
	if(value>9||value<1)
	{
		cout<<endl<<value<<" is out of the range 1-9.\n";
		return false;
	}
	if(s.possibles[value-1]==0)
	{
		cout<<endl<<value<<" is not a possibility in this square\n";
		return false;
	}
	if(s.set)
		cout<<"\nThe square is already set\n";
	else
		for(p_size i=0; i!=s.possibles.size();i++)
		{
			if(i!=value-1)
				s.possibles[i]=0;
			s.set=true;
		}
	return true;
}
